package com.hotwj.platform.driverManagement.inviteLog.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.driverManagement.inviteLog.domain.HotDriverInviteLog;
import com.hotwj.platform.driverManagement.inviteLog.domain.bo.HotDriverInviteLogBo;
import com.hotwj.platform.driverManagement.inviteLog.domain.vo.HotDriverInviteLogVo;
import com.hotwj.platform.driverManagement.inviteLog.mapper.HotDriverInviteLogMapper;
import com.hotwj.platform.driverManagement.inviteLog.service.IHotDriverInviteLogService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 驾驶员邀请码使用记录Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-19
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotDriverInviteLogServiceImpl implements IHotDriverInviteLogService {

    private final HotDriverInviteLogMapper baseMapper;

    /**
     * 查询驾驶员邀请码使用记录
     *
     * @param id 主键
     * @return 驾驶员邀请码使用记录
     */
    @Override
    public HotDriverInviteLogVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询驾驶员邀请码使用记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 驾驶员邀请码使用记录分页列表
     */
    @Override
    public TableDataInfo<HotDriverInviteLogVo> queryPageList(HotDriverInviteLogBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotDriverInviteLog> lqw = buildQueryWrapper(bo);
        Page<HotDriverInviteLogVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的驾驶员邀请码使用记录列表
     *
     * @param bo 查询条件
     * @return 驾驶员邀请码使用记录列表
     */
    @Override
    public List<HotDriverInviteLogVo> queryList(HotDriverInviteLogBo bo) {
        LambdaQueryWrapper<HotDriverInviteLog> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotDriverInviteLog> buildQueryWrapper(HotDriverInviteLogBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotDriverInviteLog> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotDriverInviteLog::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getInviteCode()), HotDriverInviteLog::getInviteCode, bo.getInviteCode());
        lqw.eq(bo.getCompanyId() != null, HotDriverInviteLog::getCompanyId, bo.getCompanyId());
        lqw.eq(StringUtils.isNotBlank(bo.getDriverId()), HotDriverInviteLog::getDriverId, bo.getDriverId());
        lqw.like(StringUtils.isNotBlank(bo.getDriverName()), HotDriverInviteLog::getDriverName, bo.getDriverName());
        lqw.eq(StringUtils.isNotBlank(bo.getDriverPhone()), HotDriverInviteLog::getDriverPhone, bo.getDriverPhone());
        return lqw;
    }

    /**
     * 新增驾驶员邀请码使用记录
     *
     * @param bo 驾驶员邀请码使用记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotDriverInviteLogBo bo) {
        HotDriverInviteLog add = MapstructUtils.convert(bo, HotDriverInviteLog.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改驾驶员邀请码使用记录
     *
     * @param bo 驾驶员邀请码使用记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotDriverInviteLogBo bo) {
        HotDriverInviteLog update = MapstructUtils.convert(bo, HotDriverInviteLog.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotDriverInviteLog entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除驾驶员邀请码使用记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
